#ifndef _LINUX_PAGE_H
#define _LINUX_PAGE_H

/* in page.h */
typedef struct { unsigned long pgprot; } pgprot_t;
#define __pgprot(x)     ((pgprot_t) { (x) } )

/* in page-flags.h */
#define SetPageReserved(page)   do {} while (0) // set_bit(PG_reserved, &(page)->flags)
#define ClearPageReserved(page) do {} while (0) // clear_bit(PG_reserved, &(page)->flags)

/* end page-flags.h */

/* in pgtable.h */

/* XXX remap to freebsd */
#define _PAGE_PRESENT   0x001
#define _PAGE_RW        0x002
#define _PAGE_USER      0x004
#define _PAGE_ACCESSED  0x020

#define PAGE_SHARED \
        __pgprot(_PAGE_PRESENT | _PAGE_RW | _PAGE_USER | _PAGE_ACCESSED)
int remap_pfn_range(struct vm_area_struct *, unsigned long addr,
                        unsigned long pfn, unsigned long size, pgprot_t);

/*
 * XXX these need to be remapped to the FreeBSD equivalent.
 */
struct page;
struct page *vmalloc_to_page(void *addr);

/* Align the pointer to the (next) page boundary.
 * Note that on FreeBSD, PAGE_MASK = PAGE_SIZE -1,
 * whereas on Linux PAGE_MASK = (~(PAGE_SIZE-1))
 */
 
#define PAGE_ALIGN(addr)        (((addr)+PAGE_SIZE-1)&(~(PAGE_SIZE - 1)))

void *page_address(struct page *page);

/*
 * I think PAGE_OFFSET is the start of the kernel (virtual?) addres space.
 * Let's set it at 0xC0000000 for the time being. Not sure it is correct.
 * XXX note, this stuff is used in the mmap support.
 */
#define PAGE_OFFSET	0xC0000000	// XXX check it...
#define __pa(x)                 ((unsigned long)(x)-PAGE_OFFSET)

#endif /* _LINUX_PAGE_H */
